<template>
  <div>
    <!--        顶部条-->
    <div class="navBarTOP">
      <van-nav-bar class="navBar" title="半月报审批" left-arrow @click-left="onClickLeft" />
    </div>
    <!--        主体内容-->

    <div class="container linep">
      <div class="lineGrey"></div>
      <div class="lineGrey"></div>
      <div class="lineGrey"></div>
      <div class="lineGrey"></div>
      <div class="lineGrey"></div>
      <van-collapse v-model="activeNames">
        <template v-if="reportTarget.postType == 'GZ' || reportTarget.BMDType == 'BMD'">
          <!-- 0-历史指标  1-动态指标，String类型 -->
          <template v-if="reportTarget.targetType == '1'">
            <target :homePageIndicatorDate="homePageIndicatorList"></target>
          </template>
          <template v-if="reportTarget.targetType == '0'">
            <Atarget :reportInfo="reportTarget"></Atarget>
            <Btarget :reportInfo="reportTarget"></Btarget>
          </template>
        </template>
        <template v-else>
          <Atarget :reportInfo="reportTarget"></Atarget>
          <Btarget :reportInfo="reportTarget"></Btarget>
        </template>
        <div class="contentContainer" v-if="reportTarget.isHistory == '0'">
          <!-- isHistory 是否为历史汇报：0-新汇报 1-历史汇报 -->

          <reportCustom
            ref="reportCustom"
            :disabled="true"
            :reportCustomData="reportTarget.customTaskList"></reportCustom>
        </div>
        <template v-else>
          <van-collapse-item title="上期工作成果" name="7">
            <div style="margin-top: -10px">
              <div v-for="(item, index) in reportContentsList2" :key="index">
                <!--              <p class="texttitle"><span class="opint"></span><span>{{selectDictLabel(weekType,item.doubleWeekType)}}</span></p>-->
                <p class="texttitle texttitle2">计划工作进度</p>
                <div style="padding: 10px 0; min-height: 32px" class="contentContainer">
                  <van-field
                    v-model="reportContentsList1[index].doubleWeekContent"
                    rows="4"
                    autosize
                    readonly
                    type="textarea" />
                </div>
                <p class="texttitle texttitle2">实际工作进度</p>
                <div style="padding: 10px 0; min-height: 32px" class="contentContainer">
                  <van-field
                    v-model="item.doubleWeekContent"
                    rows="4"
                    autosize
                    readonly
                    type="textarea" />
                </div>
              </div>
            </div>
          </van-collapse-item>
          <van-collapse-item title="本期工作规划" name="8">
            <div style="margin-top: -10px">
              <div v-for="(item2, index2) in reportContentsList3" :key="index2">
                <!--              <p class="texttitle"><span class="opint"></span><span>{{selectDictLabel(weekType,item2.doubleWeekType)}}</span></p>-->
                <div style="padding: 10px 0; min-height: 32px" class="contentContainer">
                  <van-field
                    v-model="item2.doubleWeekContent"
                    rows="4"
                    autosize
                    readonly
                    type="textarea" />
                </div>
              </div>
            </div>
          </van-collapse-item>
        </template>
      </van-collapse>
      <div class="contentContainer">
        <p class="contentContainerTitle">打分 <span>请点亮小星星，一颗小星星代表1分</span></p>
        <div style="padding: 10px 0">
          <van-rate
            v-model="number"
            :size="25"
            color="#ffd21e"
            void-icon="star"
            void-color="#eee" />
          <span class="rateText">&nbsp;&nbsp;&nbsp;&nbsp;{{ number }}分</span>
        </div>
      </div>
      <div class="contentContainer">
        <p class="contentContainerTitle">评语</p>
        <div style="padding: 10px 0">
          <van-field
            v-model="Content"
            rows="4"
            autosize
            type="textarea"
            maxlength="800"
            show-word-limit
            :formatter="formatter" />
        </div>
      </div>
      <br />
      <br />
      <van-row>
        <van-col span="12">
          <van-button type="info" size="small" plain class="Btn" @click="submit"
            >确认审批</van-button
          >
        </van-col>
        <van-col span="12">
          <van-button type="info" size="small" plain class="BtnBorder" @click="reject"
            >退回重写</van-button
          >
        </van-col>
      </van-row>
    </div>
    <br />
    <br />
    <br />
    <br />
  </div>
</template>

<script>
import { double_week_type, updateReport, getDetailById, getReportInfo } from '@/api/index';
import createStoreBJ from '@/views/componentsTarget/createStoreBJ';
import ZYPlaceOrder from '@/views/componentsTarget/ZYPlaceOrder';
import performanceSAP from '@/views/componentsTarget/performanceSAP';
import ZYSAP from '@/views/componentsTarget/ZYSAP';
import veryGoodPlaceOrder from '@/views/componentsTarget/veryGoodPlaceOrder';
import neiwaiqiangpingtu from '@/views/componentsTarget/neiwaiqiangpingtu';
import zhiganwaiqiangSAP from '@/views/componentsTarget/zhiganwaiqiangSAP';
import Atarget from '@/views/home/Atarget.vue';
import Btarget from '@/views/home/Btarget.vue';
import reportCustom from './reportCustom.vue';
import target from './target.vue';

export default {
  name: 'home',
  components: {
    createStoreBJ,
    ZYPlaceOrder,
    performanceSAP,
    ZYSAP,
    veryGoodPlaceOrder,
    neiwaiqiangpingtu,
    zhiganwaiqiangSAP,
    Atarget,
    Btarget,
    reportCustom,
    target,
  },
  data() {
    return {
      form: { rate: 0, message: '' },
      activeNames: [
        '1',
        '2',
        '3',
        '4',
        '5',
        '6',
        '7',
        '8',
        '11',
        '12',
        '16',
        '17',
        '27',
        '28',
        '29',
      ],
      powerGrade: '',
      value: '2',
      Content: '',
      number: 0,
      timeList: [],
      reportTargetAll: {},
      reportContentsList1: [],
      reportContentsList2: [],
      reportContentsList3: [],
      updateReport: {},
      weekType: [],
      type: '-1',
      JZQuota: false,
      reportTarget: {},
      homePageIndicatorList: null,
    };
  },
  created() {
    this.powerGrade = localStorage.getItem('powerGrade');
    this.getReportInfo();
    double_week_type().then((res) => {
      this.weekType = res.data;
    });
  },
  watch: {
    $route(to, from) {
      this.powerGrade = localStorage.getItem('powerGrade');
      if (to.path == '/doubleWeeklyApproval') {
        this.getDetailById();
        this.number == 0;
        this.Content = '';
      }
    },
  },
  methods: {
    formatter(value) {
      return value.replace(
        /[\uD83C|\uD83D|\uD83E][\uDC00-\uDFFF][\u200D|\uFE0F]|[\uD83C|\uD83D|\uD83E][\uDC00-\uDFFF]|[0-9|*|#]\uFE0F\u20E3|[0-9|#]\u20E3|[\u203C-\u3299]\uFE0F\u200D|[\u203C-\u3299]\uFE0F|[\u2122-\u2B55]|\u303D|[\A9|\AE]\u3030|\uA9|\uAE|\u3030/gi,
        '',
      );
    },
    reject() {
      let loading1 = this.$toast.loading({
        duration: 0,
        message: '数据提交中...',
        forbidClick: true,
      });
      if (this.Content.trim() == '') {
        this.$toast('评语未填写');
        return false;
      }
      if (this.Content.length > 800) {
        this.$toast('评语内容不能超过800字');
        return false;
      }
      this.reportTarget.number = this.number;
      this.reportTarget.failContent = this.Content;
      this.reportTarget.failContent = this.reportTarget.failContent;
      this.reportTarget.status = 2;
      updateReport(this.reportTarget).then((res) => {
        loading1.clear();
        if (res.code == 200) {
          this.$dialog
            .alert({
              title: '系统提示',
              message: '提交成功',
            })
            .then(() => {
              window.location.replace(
                window.location.origin + this.locationOrigin + '/dailyApprovalList',
              );
            });
        } else {
          this.$toast.fail(res.msg);
        }
      });
    },
    submit() {
      let loading1 = this.$toast.loading({
        duration: 0,
        message: '数据提交中...',
        forbidClick: true,
      });
      if (this.number == '0') {
        this.$toast('评分未选择');
        return false;
      }
      if (this.Content.trim() == '') {
        this.$toast('评语未填写');
        return false;
      }
      if (this.Content.length > 800) {
        this.$toast('评语内容超过800字');
        return false;
      }
      this.reportTarget.number = this.number;
      this.reportTarget.successContent = this.Content;
      this.reportTarget.successContent = this.reportTarget.successContent;
      this.reportTarget.status = 3;
      updateReport(this.reportTarget).then((res) => {
        loading1.clear();
        if (res.code == 200) {
          this.$dialog
            .alert({
              title: '系统提示',
              message: '提交成功',
            })
            .then(() => {
              window.location.replace(
                window.location.origin + this.locationOrigin + '/dailyApprovalList',
              );
            });
        } else {
          this.$toast.fail(res.msg);
        }
      });
    },
    getReportInfo() {
      let loading1 = this.$toast.loading({
        duration: 0,
        message: '加载中...',
        forbidClick: true,
      });
      getDetailById({ reportId: this.$route.query.reportId }).then((res) => {
        loading1.clear();
        if (res.code == 200) {
          if (res.data.status != '1') {
            this.$dialog
              .alert({
                title: '系统提示',
                message: '半月报已审批',
              })
              .then(() => {
                window.location.replace(window.location.origin + this.locationOrigin + '/home');
              });
          } else {
            this.homePageIndicatorList = res.data.homePageIndicatorList;
            this.reportTargetAll = res.data.reportTargetAll;
            this.reportTarget = res.data;
            this.type = res.data.userType;
            this.reportContents = res.data.reportContents;
            var reportContentsList1 = [];
            var reportContentsList2 = [];
            var reportContentsList3 = [];
            var reportContentsdata = res.data.reportContents;
            for (var i = 0; i < res.data.reportContents.length; i++) {
              if (res.data.reportContents[i].type == '1') {
                reportContentsList1.push(reportContentsdata[i]);
              }
              if (res.data.reportContents[i].type == '2') {
                reportContentsList2.push(reportContentsdata[i]);
              }
              if (res.data.reportContents[i].type == '3') {
                reportContentsList3.push(reportContentsdata[i]);
              }
            }
            var ln1 = reportContentsList1.length;
            var ln2 = reportContentsList2.length;
            if (reportContentsList2.length > reportContentsList1.length) {
              var len = ln2 - ln1;
              for (var x = 0; x < len; x++) {
                reportContentsList1.push({
                  doubleWeekContent: '',
                });
              }
            }
            this.reportContentsList1 = reportContentsList1;
            this.reportContentsList2 = reportContentsList2;
            this.reportContentsList3 = reportContentsList3;
          }
        } else {
          this.$toast(res.msg);
        }
      });
    },
    onClickLeft() {
      this.$router.go(-1);
    },
  },
};
</script>
<style scoped>
.container {
  margin: 10px;
}

.container .van-collapse-item {
  margin-bottom: 16px;
}

.linep p {
  margin: 6px 0 0 0;
  font-size: 14px;
  color: #666;
  padding-left: 6px;
}

.linep .texttitle {
  color: #0057ba;
  position: relative;
  padding-left: 10px;
}

.linep .texttitle2 {
  padding-left: 10px;
}

.linep .texttitle .opint {
  position: absolute;
  left: 0px;
  top: 6px;
  margin-right: 6px;
  display: inline-block;
  width: 6px;
  height: 6px;
  border-radius: 10px;
  background-color: #004d8c;
}

.leftTitle {
  background-color: #74a4d9;
  color: #fff;
  display: inline-block;
  padding: 0 4px;
  border-radius: 2px;
}

.rightTitle {
  background-color: #e7b4bb;
  color: #fff;
  display: inline-block;
  padding: 0 4px;
  border-radius: 2px;
}
</style>
<style>
.linep .van-cell__title {
  color: #1e5398;
  font-weight: 500;
}

.Btn {
  margin: 0 auto 10px;
  display: block;
  width: 90%;
  border-radius: 5px;
  color: #fff !important;
  background-color: #0057ba;
  border: 1px solid #0057ba;
  height: 36px;
}
.BtnBorder {
  margin: 0 auto 10px;
  display: block;
  width: 90%;
  border-radius: 5px;
  border: 1px solid #0057ba;
  color: #0057ba;
  height: 36px;
}
.linep .contentContainer {
  background-color: white;
  border-radius: 8px;
  padding: 10px 16px;
  margin-bottom: 10px;
}

.linep .contentContainer .contentContainerTitle {
  color: #222;
}

.linep .contentContainer .contentContainerTitle span {
  font-size: 12px;
  color: #666;
}

.linep .contentContainer .van-field__control,
.linep .contentContainerp .van-field__control {
  background-color: #f8f8f8;
  padding: 10px;
  border-radius: 8px;
}

.linep .contentContainer .van-cell,
.linep .contentContainerp .van-cell {
  padding: 0;
}
.van-dialog__confirm,
.van-dialog__confirm:active {
  color: #0057ba;
}
</style>
